<?php
 
 
 

namespace PhpWA\Protocol\Proto\BotSourcesMetadata;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class BotSourceItem extends \Google\Protobuf\Internal\Message
{
    


    protected $provider = null;
    


    protected $thumbnailCdnUrl = null;
    


    protected $sourceProviderUrl = null;
    


    protected $sourceQuery = null;
    


    protected $faviconCdnUrl = null;
    


    protected $citationNumber = null;
    


    protected $sourceTitle = null;

    














    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getProvider()
    {
        return isset($this->provider) ? $this->provider : 0;
    }

    public function hasProvider()
    {
        return isset($this->provider);
    }

    public function clearProvider()
    {
        unset($this->provider);
    }

    




    public function setProvider($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotSourcesMetadata\BotSourceItem\SourceProvider::class);
        $this->provider = $var;

        return $this;
    }

    



    public function getThumbnailCdnUrl()
    {
        return isset($this->thumbnailCdnUrl) ? $this->thumbnailCdnUrl : '';
    }

    public function hasThumbnailCdnUrl()
    {
        return isset($this->thumbnailCdnUrl);
    }

    public function clearThumbnailCdnUrl()
    {
        unset($this->thumbnailCdnUrl);
    }

    




    public function setThumbnailCdnUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->thumbnailCdnUrl = $var;

        return $this;
    }

    



    public function getSourceProviderUrl()
    {
        return isset($this->sourceProviderUrl) ? $this->sourceProviderUrl : '';
    }

    public function hasSourceProviderUrl()
    {
        return isset($this->sourceProviderUrl);
    }

    public function clearSourceProviderUrl()
    {
        unset($this->sourceProviderUrl);
    }

    




    public function setSourceProviderUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->sourceProviderUrl = $var;

        return $this;
    }

    



    public function getSourceQuery()
    {
        return isset($this->sourceQuery) ? $this->sourceQuery : '';
    }

    public function hasSourceQuery()
    {
        return isset($this->sourceQuery);
    }

    public function clearSourceQuery()
    {
        unset($this->sourceQuery);
    }

    




    public function setSourceQuery($var)
    {
        GPBUtil::checkString($var, True);
        $this->sourceQuery = $var;

        return $this;
    }

    



    public function getFaviconCdnUrl()
    {
        return isset($this->faviconCdnUrl) ? $this->faviconCdnUrl : '';
    }

    public function hasFaviconCdnUrl()
    {
        return isset($this->faviconCdnUrl);
    }

    public function clearFaviconCdnUrl()
    {
        unset($this->faviconCdnUrl);
    }

    




    public function setFaviconCdnUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->faviconCdnUrl = $var;

        return $this;
    }

    



    public function getCitationNumber()
    {
        return isset($this->citationNumber) ? $this->citationNumber : 0;
    }

    public function hasCitationNumber()
    {
        return isset($this->citationNumber);
    }

    public function clearCitationNumber()
    {
        unset($this->citationNumber);
    }

    




    public function setCitationNumber($var)
    {
        GPBUtil::checkUint32($var);
        $this->citationNumber = $var;

        return $this;
    }

    



    public function getSourceTitle()
    {
        return isset($this->sourceTitle) ? $this->sourceTitle : '';
    }

    public function hasSourceTitle()
    {
        return isset($this->sourceTitle);
    }

    public function clearSourceTitle()
    {
        unset($this->sourceTitle);
    }

    




    public function setSourceTitle($var)
    {
        GPBUtil::checkString($var, True);
        $this->sourceTitle = $var;

        return $this;
    }

}

